var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ClashClient_client;
import got from 'got';
import HttpAgent, { HttpsAgent } from 'agentkeepalive';
import { CLASH_ROUTES, DELAY_TEST_TIMEOUT, DELAY_TEST_URL, } from './constants.js';
const liveOption = {
    keepAlive: true,
    maxSockets: 10,
};
export class ClashClient {
    constructor(clashConfig) {
        _ClashClient_client.set(this, void 0);
        __classPrivateFieldSet(this, _ClashClient_client, got.extend({
            prefixUrl: `${clashConfig.ssl ? 'https' : 'http'}://${clashConfig.host}:${clashConfig.port}`,
            responseType: 'json',
            headers: {
                Authorization: `Bearer ${clashConfig.secret}`,
            },
            agent: {
                http: new HttpAgent(liveOption),
                https: new HttpsAgent(liveOption),
            },
            retry: {
                limit: 0,
            },
        }), "f");
    }
    async getProxies() {
        return __classPrivateFieldGet(this, _ClashClient_client, "f").get(CLASH_ROUTES.PROXIES).json();
    }
    async getDelay(proxyName) {
        return __classPrivateFieldGet(this, _ClashClient_client, "f")
            .get({
            url: CLASH_ROUTES.DELAY(proxyName),
            searchParams: {
                timeout: DELAY_TEST_TIMEOUT,
                url: DELAY_TEST_URL,
            },
        })
            .json();
    }
    static createClient(clashConfig) {
        return new ClashClient(clashConfig);
    }
}
_ClashClient_client = new WeakMap();
//# sourceMappingURL=http.js.map