var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _InfluxClient_client, _InfluxClient_writeApi;
import { InfluxDB, Point } from '@influxdata/influxdb-client';
export class InfluxClient {
    constructor(influxConfig) {
        _InfluxClient_client.set(this, void 0);
        _InfluxClient_writeApi.set(this, void 0);
        __classPrivateFieldSet(this, _InfluxClient_client, new InfluxDB({
            url: influxConfig.url,
            token: influxConfig.token,
        }), "f");
        __classPrivateFieldSet(this, _InfluxClient_writeApi, __classPrivateFieldGet(this, _InfluxClient_client, "f").getWriteApi(influxConfig.org, influxConfig.bucket, 'ms'), "f");
    }
    async recordDelay(proxyName, delay) {
        const point = new Point('delay')
            .tag('proxy', proxyName)
            .floatField('min', delay.min)
            .floatField('max', delay.max)
            .floatField('avg', delay.avg);
        __classPrivateFieldGet(this, _InfluxClient_writeApi, "f").writePoint(point);
    }
    async close() {
        await __classPrivateFieldGet(this, _InfluxClient_writeApi, "f").close();
    }
    static createClient(influxConfig) {
        return new InfluxClient(influxConfig);
    }
}
_InfluxClient_client = new WeakMap(), _InfluxClient_writeApi = new WeakMap();
//# sourceMappingURL=influx.js.map